/*

    test disk-caches (if you have the feeling that your RAID is to slow)

     syntax: time ./disk <device/file> <len/MB> <repeat>
     Linux:  time ./disk /dev/zero 1000 1000  # 1TB/10s
     Linux:  time ./disk /dev/hda 1 1000      # 1GB/4s=250MB/s  groups=disk
     Linux:  time ./disk /dev/hda 1000 1      # 1GB/18s=56MB/s  groups=disk
     Tru64:  time ./disk /dev/rdisk/dsk1c 1 1000
     IRIX-6: time ./disk /dev/rdsk/dks4d5s7 1 1000  # 1GB/67s=15MB/s ch.
     IRIX-6: time ./disk /dev/rdsk/dks4d5s7 1000 1  # 1GB/57s=18MB/s ch.
     IRIX-6: time ./disk tmp/htmp000.001 1 1000  # 1GB/63s=15.8MB/s ch. uncached
     IRIX-6: time ./disk tmp/htmp000.001 1000 1  # 1GB/10s=100MB/s ch. cached
     IRIX-6: time ./disk tmp/htmp000.001 1 1000  # 1GB/4s=227MB/s ch. cached

     Linux:  strace -f -F -r -T -s 5 /sbin/hdparm -t /dev/hda

 */
 
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

#define BLEN (1024*1024)
char buf[BLEN];

int main(int argn, char *argv[]) {
  int fn,len,rpt,i,j;
  if (argn!=4) return 1;
  len=atoi(argv[2]);
  rpt=atoi(argv[3]);
  fn=open(argv[1],O_RDONLY); /* O_NONBLOCK */
  printf("start scan on %s fd=%d size=%d %d times ...\n",argv[1],fn,len,rpt);
  for(i=0;i<rpt;i++){
    for(j=0;j<len;j++) read(fn,buf,BLEN);
    lseek(fn,0,SEEK_SET);
  }
  printf("... finished\n");
  close(fn);
  return 0;
}
